--[[ **************************************************************************
     *  Add On Dependencies version checks                                    *
	 **************************************************************************
]]
local VerLockOut = true
local BillsUtilsReqVer = {string.split("-", GetAddOnMetadata("AchSnd", "X-BillsUtilsReqVer")) }
local BillsUtilsCurVer = {string.split("-", GetAddOnMetadata("BillsUtils", "Version")) }

if BillsUtilsCurVer[1] > BillsUtilsReqVer[1] then
	VerLockOut = false
else
	if BillsUtilsCurVer[2] > BillsUtilsReqVer[2] then
		VerLockOut = false
	else
		if BillsUtilsCurVer[3] >= BillsUtilsReqVer[3] then
			VerLockOut = false
		end
	end
end
	

if not(VerLockOut) then
	
	
-- Config Panel Text Strings
AchSnd.Text={
Title = "Achievement Sounds",
TitleSub = "Change how Achievement Sounds behaves by setting the options below",
Enable = "Enable the Add On to function",
Guild = "Trigger on guild member achievements",
Party = "Trigger on party member achievements",
Near  = "Trigger for people near you's achievements",
MSBT  = "Enable output to MSBT's notification frame",
Popup = "Enable Grats popup for 1-click gratting",
Sound = "Enable sound to notify you of an achievement",
CustomMP3 = "Enable custom alert.mp3 sound",
CustomOGG = "Enable custom alert.ogg sound",
Timeout = "Set the pop up's timeout",
Random = "Display a random grats message(checked) or default message",
Names = "Use playes's names in grat messages",
NNames = "Use Nicknames in grats when saved",
MaxNames = "Max number of names to display",
Multi = "Respond to multiple achievements with plural random msg",
MultiAmount = "    Over this amount gives a whole guild grat.",
DefaultMsg = "The message displayed if Random is off",
NewMsgBox = "Use the new \"Achievement Alert\" frame instead of old popup style. (Still needs Popup enabled to function)",
AutoFade = "Enable the new frame to fade when the mouse isn't over it",
MinAlpha = "The min. alpha the frame will fade to",
FadeDelay = "Time before frame fades to above"
}

-- Bill's Utils
local Wait = BillsUtils.Wait
local ChkBoxSave = BillsUtils.ChkBoxSave
local SliderSave = BillsUtils.SliderSave
local SliderMW = BillsUtils.SliderMW
local ChkBox = BillsUtils.ChkBox -- function( Last , Prefix, Name, Parent, Click, TextTable )
local CheckClick = BillsUtils.CheckClick
local Slider = BillsUtils.Slider
local SliderEditBox = BillsUtils.SliderEditBox
local EditBox = BillsUtils.EditBox

-- General Settings / functions
AchSnd.ConfigLoaded = false



--Panel
AchSnd.panel = CreateFrame( "Frame", "AchSndConfig", UIParent )
AchSnd.panel2 = CreateFrame( "Frame", "AchSndConfig", AchSnd.panel )
local me = AchSnd.panel
local me2 = AchSnd.panel2
me:SetScript("OnLoad", function()
	AchSnd.init()
end)


me.name = "Ach. Sounds"
me2:SetSize(380,475)
me2:SetPoint("BOTTOMLEFT", me, "BOTTOMLEFT")


local X = 16 -- standard Horizontal Spacing
local Y = 35 -- standard Vertical spacing 26
local TxtY = 13

-- Pane title
	local Title = me:CreateFontString( nil, "ARTWORK", "GameFontNormalLarge" )
	Title:SetPoint( "TOPLEFT", 16, -16 )
	Title:SetText( AchSnd.Text.Title )
	local SubText = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
	SubText:SetPoint( "TOPLEFT", Title, "BOTTOMLEFT", 0, -8 )
	SubText:SetPoint( "RIGHT", -32, 0 )
	SubText:SetHeight( 32 )
	SubText:SetJustifyH( "LEFT" )
	SubText:SetJustifyV( "TOP" )
	SubText:SetText( AchSnd.Text.TitleSub )

-- Scroll Frame
	me.ScrollFrame = CreateFrame("ScrollFrame", "AchSndConfigScrollFrame", me, "UIPanelScrollFrameTemplate")
	me.ScrollFrame:SetScrollChild(me2)
	me.ScrollFrame:SetPoint("TOPRIGHT", me ,"TOPRIGHT", -30,- 64)
	me.ScrollFrame:SetPoint("BOTTOMRIGHT", me ,"BOTTOMRIGHT", -30, 10)
	me.ScrollFrame:SetSize(390, 400)

-- Enable Checkbox and text
	me.Enable = ChkBox( me2 , "AchSndCfg", "Enable", me2, CheckClick, AchSnd.Text )
	local last = me.Enable

-- Guild Checkbox and text
	me.Guild = ChkBox( last , "AchSndCfg", "Guild", me2, CheckClick, AchSnd.Text )
	last = me.Guild

-- Party Checkbox and text
	me.Party = ChkBox( last , "AchSndCfg", "Party", me2, CheckClick, AchSnd.Text )
	last = me.Party

-- Near Checkbox and text
	me.Near = ChkBox( last , "AchSndCfg", "Near", me2, CheckClick, AchSnd.Text )
	last = me.Near

-- MSBT Checkbox and text
	me.MSBT = ChkBox( last , "AchSndCfg", "MSBT", me2, CheckClick, AchSnd.Text )
	last = me.MSBT

-- Popup Checkbox and text
	me.Popup = ChkBox( last , "AchSndCfg", "Popup", me2, CheckClick, AchSnd.Text )
	last = me.Popup


-- Timeout Slider and EditBox
	me.Timeout = Slider( last , "AchSndCfg", "Timeout", me2 , SliderMW , AchSnd.Text, 0, 60, 1 )
	last = me.Timeout
	me.Timeout.Val = SliderEditBox( last , "AchSndCfg", "Timeout", me2 )

-- Sound Checkbox and text
	me.Sound = ChkBox( last , "AchSndCfg", "Sound", me2, CheckClick, AchSnd.Text )
	last = me.Sound

-- Custom MP3 Checkbox and text
	me.CustomMP3 = ChkBox( last , "AchSndCfg", "CustomMP3", me2, CheckClick, AchSnd.Text )
	last = me.CustomMP3

-- Custom OGG Checkbox and text
	me.CustomOGG = ChkBox( last , "AchSndCfg", "CustomOGG", me2, CheckClick, AchSnd.Text )
	last = me.CustomOGG

-- Random Message Checkbox and text
	me.Random = ChkBox( last , "AchSndCfg", "Random", me2, CheckClick, AchSnd.Text )
	last = me.Random

-- Names in Random messages checkbox and text
	me.Names = ChkBox( last , "AchSndCfg", "Names", me2, CheckClick, AchSnd.Text )
	last = me.Names

-- NickNames in Random messages checkbox and text
	me.NNames = ChkBox( last , "AchSndCfg", "NNames", me2, CheckClick, AchSnd.Text )
	last = me.NNames

-- MaxNames Slider and EditBox
	me.MaxNames = Slider( last , "AchSndCfg", "MaxNames", me2 , SliderMW , AchSnd.Text, 1, 10, 1 )
	last = me.MaxNames
	me.MaxNames.Val = SliderEditBox( last , "AchSndCfg", "MaxNames", me2 )

-- Multi Grat Message Checkbox and text
	me.Multi = ChkBox( last , "AchSndCfg", "Multi", me2, CheckClick, AchSnd.Text )
	last = me.Multi

-- MultiAmount Slider and EditBox and text
	me.MultiAmount = Slider( last , "AchSndCfg", "MultiAmount", me2 , SliderMW , AchSnd.Text, 0, 129, 1 )
	last = me.MultiAmount
	me.MultiAmount.Val = SliderEditBox( last , "AchSndCfg", "MultiAmount", me2 )

-- Default Message Editbox 
	me.Default = EditBox( last, "AchSndCfg", "Default", me2, AchSnd_Settings, "DefaultMsg", AchSnd.Text )
	last = me.Default
	
-- New Alert Checkbox and text
	me.NewMsgBox = ChkBox( last , "AchSndCfg", "NewMsgBox", me2, CheckClick, AchSnd.Text )
	last = me.NewMsgBox

-- New Alert Autofade Checkbox and text
	me.AutoFade = ChkBox( last , "AchSndCfg", "AutoFade", me2, CheckClick, AchSnd.Text )
	last = me.AutoFade

-- Alert Frame Minimum Alpha Slider and EditBox
	me.MinAlpha = Slider( last , "AchSndCfg", "MinAlpha", me2 , SliderMW , AchSnd.Text, 0, 100, 5 )
	last = me.MinAlpha
	me.MinAlpha.Val = SliderEditBox( last , "AchSndCfg", "MinAlpha", me2 )

-- Alert Frame Fade Delay Slider and editbox
	me.FadeDelay = Slider( last , "AchSndCfg", "FadeDelay", me2 , SliderMW , AchSnd.Text, 0, 60, 0.5 )
	last = me.FadeDelay
	me.FadeDelay.Val = SliderEditBox( last , "AchSndCfg", "FadeDelay", me2 )
	
-- Frame Settings Test Button 
	me.TestButton = CreateFrame("Button", "AchSndTestButton", me2, "UIPanelButtonTemplate" )
	me.TestButton:SetPoint("TOPLEFT", last, "TOPLEFT", ((me2:GetWidth() / 2) -75) , -Y )
	me.TestButton:SetSize( 150, 25)
	me.TestButton:SetText("Test")
	me.TestButton:SetScript("OnClick", function(self, button, down)
		if (button ~= "LeftButton") then
			return
		end
		PlaySound( "GAMEGENERICBUTTONPRESS" )
		AchSnd.MBox.Test = true
		AchSnd.MBox.text = "This is a test for checking the Alpha of the frame"
		GameMenuFrame:Hide()
		InterfaceOptionsFrame:Hide()
		AchSnd.MsgFrame:Show()
		return
	end)
	
--	End of frame
-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
-- X  Init / Reset the config panel to match current settings                                                     X
-- XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
--


AchSnd.Init = function(...)
	if (AchSnd.MBox.mode == "TEST") then
		return
	end
	
	local setting = AchSnd_Settings
	local me = AchSnd.panel
	me.Enable:SetChecked( setting.Enable )
	me.Guild:SetChecked( setting.Guild )
	me.Party:SetChecked( setting.Party )
	me.Near:SetChecked( setting.Near )
	me.MSBT:SetChecked( setting.MSBT )
	me.Popup:SetChecked( setting.Popup )
	me.Timeout:SetValue( setting.Timeout)
	me.Timeout.Val:SetCursorPosition( 0 )
	me.Timeout.Val:SetNumber( setting.Timeout )
	me.Sound:SetChecked( setting.Sound )
	me.CustomMP3:SetChecked( setting.CustomMP3 )
	me.CustomOGG:SetChecked( setting.CustomOGG )
	me.Random:SetChecked( setting.Random )
	me.Names:SetChecked( setting.Names )
	me.NNames:SetChecked( setting.NNames )
	me.MaxNames:SetValue( setting.MaxNames)
	me.MaxNames.Val:SetCursorPosition( 0 )
	me.MaxNames.Val:SetNumber( setting.MaxNames )
	me.Multi:SetChecked( setting.Multi )
	me.MultiAmount:SetValue( setting.MultiAmount)
	me.MultiAmount.Val:SetCursorPosition( 0 )
	me.MultiAmount.Val:SetNumber( setting.MultiAmount )
	me.Default:SetCursorPosition( 0 )
	me.Default:SetText( setting.DefaultMsg )
	me.NewMsgBox:SetChecked( setting.NewMsgBox )
	me.AutoFade:SetChecked( setting.AutoFade )
	me.MinAlpha:SetValue( setting.MinAlpha)
	me.MinAlpha.Val:SetCursorPosition( 0 )
	me.MinAlpha.Val:SetNumber( setting.MinAlpha )
	me.FadeDelay:SetValue( setting.FadeDelay)
	me.FadeDelay.Val:SetCursorPosition( 0 )
	me.FadeDelay.Val:SetNumber( setting.FadeDelay )
	
end

-- Reset config panel and settings to DEFAULT
AchSnd.Reset = function(...)
	local def = AchSnd_Defaults
	local cur = AchSnd_Settings
	cur.Enable = def.Enable
	cur.Guild = def.Guild
	cur.Party = def.Party
	cur.Near = def.Near
	cur.MSBT = def.MSBT
	cur.Popup = def.Popup
	cur.Timeout = def.Timeout
	cur.Sound = def.Sound
	cur.CustomMP3 = def.CustomMP3
	cur.CustomOGG = def.CustomOGG
	cur.Random = def.Random
	cur.Names = def.Names
	cur.NNames = def.NNames
	cur.MaxNames = def.MaxNames
	cur.Multi = def.Multi
	cur.MiltiAmount = def.MultiAmount
	cur.DefaultMsg = def.DefaultMsg
	cur.NewMsgBox = def.NewMsgBox
	cur.AutoFade = def.AutoFade
	cur.MinAlpha = def.MinAlpha
	cur.FadeDelay = def.FadeDelay
	AchSnd.Init()
end



me.refresh = function(self)
	AchSnd.Init()
end

me.default = function (self)
	AchSnd.Reset()
end

me.cancel = function (self)
	AchSnd.Init()
end


-- Save settings from config panel
me.okay = function(self)
	local setting = AchSnd_Settings
	
	ChkBoxSave( AchSnd.panel, "Enable", AchSnd_Settings) -- Enable CheckBox
	ChkBoxSave( AchSnd.panel, "Guild", AchSnd_Settings) -- Guild CheckBox
	ChkBoxSave( AchSnd.panel, "Party", AchSnd_Settings) --Party CheckBox
	ChkBoxSave( AchSnd.panel, "Near", AchSnd_Settings) -- Near CheckBox
	ChkBoxSave( AchSnd.panel, "MSBT", AchSnd_Settings) -- MSBT CheckBox
	ChkBoxSave( AchSnd.panel, "Popup", AchSnd_Settings) -- Popup CheckBox
	SliderSave( AchSnd.panel, "Timeout", AchSnd_Settings) -- Timeout Slider
	ChkBoxSave( AchSnd.panel, "Sound", AchSnd_Settings) -- Sound CheckBox
	ChkBoxSave( AchSnd.panel, "CustomMP3", AchSnd_Settings)-- CustomMP3 CheckBox
	ChkBoxSave( AchSnd.panel, "CustomOGG", AchSnd_Settings) -- CustomOGG CheckBox
	ChkBoxSave( AchSnd.panel, "Random", AchSnd_Settings) -- Random Message Enable CheckBox
	ChkBoxSave( AchSnd.panel, "Names", AchSnd_Settings) -- Use Names in Random Message Enable CheckBox
	ChkBoxSave( AchSnd.panel, "NNames", AchSnd_Settings) -- Use NickNames in Random Message Enable CheckBox
	SliderSave( AchSnd.panel, "MaxNames", AchSnd_Settings)	-- Max Names Slider
	ChkBoxSave( AchSnd.panel, "Multi", AchSnd_Settings) -- Multi Guild Message Enable CheckBox
	SliderSave( AchSnd.panel, "MultiAmount", AchSnd_Settings) -- Multi Amount Slider
	
	-- Default Message EditBox
	if (me.Default:GetText() ~= setting.DefaultMsg) then
		setting.DefaultMsg = me.Default:GetText()
	end
	
	ChkBoxSave( AchSnd.panel, "NewMsgBox", AchSnd_Settings) -- New Alert Frame Enable Checkbox
	ChkBoxSave( AchSnd.panel, "AutoFade", AchSnd_Settings) -- New Alert Frame Auto Fade Enable Checkbox
	SliderSave( AchSnd.panel, "MinAlpha", AchSnd_Settings) -- Min Alpha Slider
	SliderSave( AchSnd.panel, "FadeDelay", AchSnd_Settings) -- Fade Delay Slider
	
end

-- Register the config panel
InterfaceOptions_AddCategory( me )


-- ****************************************************************************
-- * Nick Name Child Panel -- -- -- UNDER CONSTRUCTION                        *
-- ****************************************************************************


--Panel
AchSnd.panel3 = CreateFrame( "Frame", "AchSndNNConfig", UIParent )
local me = AchSnd.panel3
me.NButtons = {}
me.NNButtons = {}

me.name = "Nick Names"
me.parent = AchSnd.panel.name

local X = 16 -- standard Horizontal Spacing
local Y = 35 -- standard Vertical spacing 26
local TxtY = 13
local e = 0

AchSnd.EBoxUpdate = function(count)
	local NN = AchSnd.NNTable
	local maxcount = #NN.Names
	local slider = me.slider:GetValue()
	
	if count + slider > maxcount then
		me.NBox:SetText("")
		me.NNBox:SetText("")
	else
		me.NBox:SetText(NN.Names[count + slider])
		me.NNBox:SetText(NN.Nicks[count + slider])
	end
end


AchSnd.NNDisplayUpdate = function()
	local NN = AchSnd.NNTable
	local maxcount = #NN.Names
	local slider = me.slider:GetValue()
	
	
	for x = 1 , 10 do
		if x + slider > maxcount then
			me.NButtons[x]:SetText( " " )
			me.NNButtons[x]:SetText( " " )
		else
			me.NButtons[x]:SetText( NN.Names[x + slider] )
			me.NNButtons[x]:SetText( NN.Nicks[x + slider] )
		end
	end
	me.slider:SetMinMaxValues( 0, (#NN.Names > 10 and #NN.Names - 10) or 1 )
end


-- Pane title
local Title = me:CreateFontString( nil, "ARTWORK", "GameFontNormalLarge" )
Title:SetPoint( "TOPLEFT", 16, -16 )
Title:SetText( "Nick Names" )
local SubText = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
SubText:SetPoint( "TOPLEFT", Title, "BOTTOMLEFT", 0, -8 )
SubText:SetPoint( "RIGHT", -32, 0 )
SubText:SetHeight( 32 )
SubText:SetJustifyH( "LEFT" )
SubText:SetJustifyV( "TOP" )
SubText:SetText( "Setup your aliases here"  )
	
local last = me
local width = 150

for x = 1, 10 do
	me.NButtons[x] = CreateFrame("Button", "AchSndNameListButton"..tostring(x), me, "UIPanelButtonTemplate" )
	me.NNButtons[x] = CreateFrame("Button", "AchSndNNameListButton"..tostring(x), me, "UIPanelButtonTemplate" )
	if last == me then
		me.NButtons[x]:SetPoint("TOPLEFT", last, "TOPLEFT", 20, -60 )
	else
		me.NButtons[x]:SetPoint("TOPLEFT", last, "BOTTOMLEFT" )
	end
	me.NButtons[x]:SetSize( width , 20)
	me.NButtons[x]:SetText( " " )
	me.NButtons[x].count = x
	me.NButtons[x]:SetScript("OnClick", function(self, button, down)
		if (button ~= "LeftButton") then
			return
		end
		PlaySound( "GAMEGENERICBUTTONPRESS" )
		AchSnd.EBoxUpdate( self.count )
		return
	end)
	
	me.NNButtons[x]:SetPoint("TOPLEFT", me.NButtons[x], "TOPRIGHT" )
	me.NNButtons[x]:SetSize( width , 20)
	me.NNButtons[x]:SetText( " " )
	me.NNButtons[x].count = x
	me.NNButtons[x]:SetScript("OnClick", function(self, button, down)
		if (button ~= "LeftButton") then
			return
		end
		PlaySound( "GAMEGENERICBUTTONPRESS" )
		AchSnd.EBoxUpdate( self.count )
		return
	end)
	last = me.NButtons[x]
end

me.slider = CreateFrame( "Slider", "NAlertNNSlider", me, "OptionsSliderTemplate" )
me.slider:SetMinMaxValues( 0, 1 )
me.slider:SetOrientation("VERTICAL")
me.slider:SetPoint("TOPLEFT", me.NNButtons[1] ,"TOPRIGHT", 5 , 0)
me.slider:SetPoint("BOTTOMLEFT", me.NNButtons[10] ,"BOTTOMRIGHT", 5 , 0)
me.slider:SetValueStep( 1 )
me.slider:SetValue( 0 )
me.slider:SetWidth( 16 )	
me.slider:SetScript( "OnValueChanged", function( self )
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	AchSnd.NNDisplayUpdate()
end)
getglobal(me.slider:GetName() .. 'Low'):SetText( "" )
getglobal(me.slider:GetName() .. 'High'):SetText( "" )
me.slider:SetScript("OnMouseWheel", function(self, delta)
	SliderMW(self, -delta)
end)

local eboxwidth = 150

me.NBox = CreateFrame( "EditBox", "AchSndNEditbox", me, "InputBoxTemplate" )
me.NBox:SetFontObject("ChatFontNormal")
me.NBox:SetTextInsets(0, 0, 3, 3)
me.NBox:SetPoint("BOTTOMLEFT", me , "BOTTOMLEFT", 30 , 50 )
--me.NBox:SetPoint("RIGHT", -32, 0)
me.NBox:SetHeight(19)
me.NBox:SetWidth( eboxwidth )
me.NBox:SetAutoFocus(false)
me.NBox:SetMaxLetters( 254 )
me.NBox:SetScript("OnEnterPressed" , function(self)
	self:ClearFocus()
end)
me.NBox:SetScript("OnEscapePressed", function(self)
	self:SetText( "" )
	self:ClearFocus()
end)

me.NBox.Text = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
me.NBox.Text:SetPoint( "BOTTOMLEFT", me.NBox , "BOTTOMLEFT", 0 , Y/4 )
me.NBox.Text:SetPoint( "RIGHT", -32, 0 )
me.NBox.Text:SetHeight( 32 )
me.NBox.Text:SetJustifyH( "LEFT" )
me.NBox.Text:SetJustifyV( "TOP" )
me.NBox.Text:SetText( "Name:" )

me.NNBox = CreateFrame( "EditBox", "AchSndNNEditbox", me, "InputBoxTemplate" )
me.NNBox:SetFontObject("ChatFontNormal")
me.NNBox:SetTextInsets(0, 0, 3, 3)
me.NNBox:SetPoint("BOTTOMLEFT", me.NBox , "BOTTOMRIGHT", 40, 0 )
-- me.NNBox:SetPoint("RIGHT", -32, 0)
me.NNBox:SetHeight(19)
me.NNBox:SetWidth( eboxwidth )
me.NNBox:SetAutoFocus(false)
me.NNBox:SetMaxLetters( 254 )
me.NNBox:SetScript("OnEnterPressed" , function(self)
	self:ClearFocus()
end)
me.NNBox:SetScript("OnEscapePressed", function(self)
	self:SetText( "" )
	self:ClearFocus()
end)

me.NNBox.Text = me:CreateFontString( nil, "ARTWORK", "GameFontHighlightSmall" )
me.NNBox.Text:SetPoint( "BOTTOMLEFT", me.NNBox , "BOTTOMLEFT", 0 , Y/4 )
me.NNBox.Text:SetPoint( "RIGHT", -32, 0 )
me.NNBox.Text:SetHeight( 32 )
me.NNBox.Text:SetJustifyH( "LEFT" )
me.NNBox.Text:SetJustifyV( "TOP" )
me.NNBox.Text:SetText( "Nickname:" )

me.AddButton = CreateFrame("Button", "AchSndNNAddButton", me, "UIPanelButtonTemplate" )
me.AddButton:SetPoint("BOTTOMLEFT", me, "BOTTOMLEFT", 20 , 20 )
me.AddButton:SetSize( 150, 25)
me.AddButton:SetText("Add")
me.AddButton:SetScript("OnClick", function(self, button, down)
	if (button ~= "LeftButton") then
		return
	end
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	if #me.NNBox:GetText() < 2 then
		return
	end

	AchSnd.Add( me.NBox:GetText(), me.NNBox:GetText() )
	me.NBox:SetText("")
	me.NBox:ClearFocus()
	me.NNBox:SetText("")
	me.NNBox:ClearFocus()
	AchSnd.NNDisplayUpdate()
	return
end)

me.DeleteButton = CreateFrame("Button", "AchSndNNDeleteButton", me, "UIPanelButtonTemplate" )
me.DeleteButton:SetPoint("BOTTOMRIGHT", me, "BOTTOMRIGHT", -20 , 20 )
me.DeleteButton:SetSize( 150, 25)
me.DeleteButton:SetText("Delete")
me.DeleteButton:SetScript("OnClick", function(self, button, down)
	if (button ~= "LeftButton") then
		return
	end
	PlaySound( "GAMEGENERICBUTTONPRESS" )
	AchSnd.Rem( me.NBox:GetText() )
	me.NBox:SetText("")
	me.NBox:ClearFocus()
	me.NNBox:SetText("")
	me.NNBox:ClearFocus()
	AchSnd.NNDisplayUpdate()
	return
end)

me:SetScript("OnUpdate", function(self, elapsed)
	e = e + elapsed
	if e < (1/10) then 
		return
	end
	e = 0
	if me.NButtons[1]:GetText() == " " then
		AchSnd.NNDisplayUpdate()
	end
	
end)

InterfaceOptions_AddCategory( me )

end -- end to huge VerLockOut if/then
